package debugger;

import java.io.*;
import java.awt.*;
import java.util.StringTokenizer;

public final class Confing {
    private static final int HEAD_LENGTH         = 35;
    public static final int SELECT_MODE_HUMANOID = 0;
    public static final int SELECT_MODE_BUILDING = 1;
    public static final int SELECT_MODE_ROAD     = 2;
    public static final int MODE_VIEWER_SIMPLE   = 0;
    public static final int MODE_VIEWER_COMPLEX  = 1;
    ////// new
    private static int     EXPAND_AREA_LENGTH= 20000;  // millimeters
    private static String  NAME_SCOPE_LOG;
    private static boolean MAKE_SCOPE_LOG    = true;
    private static boolean DRAW_OUTLINE_ROAD = false;
    private static int     MODE_VIEWER_SHOW  = MODE_VIEWER_SIMPLE;
    private static boolean SHOW_AGENT_ACTION = true;
    private static boolean SHOW_MSG_SPEAKING = true;
    private static Color COLOR_EXTINGUISHING = Color.cyan;
      /// not in confing file
    private static int     SIZE_ACTION_ANIMATION = 16;
    private static boolean IS_ONLINE       = false;
    private static boolean SHOW_WORLDMODEL = false;
    public static boolean m_showDemo = false;
    public static boolean m_showStat = false;
    private static boolean SIMPLE_STATUS = false;
    private static int    SELECT_MODE    = SELECT_MODE_HUMANOID;
    public static void changeSimpleStatus() { SIMPLE_STATUS = !SIMPLE_STATUS; }
    public static void setSelectMode(int m) { SELECT_MODE = m; }
    ///// were private
    public boolean m_sound = false;    ////// Location //////
    static Point LOCATION_ACTION_VIEWER  = new Point(918, 24);
    static Point LOCATION_MAIN_VIEW      = new Point(100, 24);
    static Dimension DIMENSION_MAIN_VIEW = new Dimension(1000, 875);
    ////// Color //////
    static Color COLOR_SELECTED  = Color.cyan;
      // object
    static Color COLOR_POLICE    = new Color(252, 221, 2);
    static Color COLOR_AMBULANCE = Color.white;
    static Color COLOR_FIRE      = Color.red;
    static Color COLOR_CIVILIAN  = Color.green;
    static Color COLOR_AMBULANCE_CENTER  = new Color(200, 200, 200);
    static Color COLOR_FIRE_STATION      = new Color(200, 200, 200);
    static Color COLOR_POLICE_OFFICE     = new Color(200, 200, 200);
    static Color COLOR_REFUGE            = new Color(80, 180, 80);
    static Color COLOR_BUILDING  = new Color(120, 120, 120);
    static Color COLOR_BUILDING_OUTLINE = Color.black;
    static Color COLOR_BUILDING_NOT_SEEN = Color.darkGray;
    static Color COLOR_BUILDING_OUTLINE_NOT_SEEN = Color.gray;
    static Color COLOR_BUILDING_FIRE[]  = {  new Color(255, 255,  255)
                                            ,new Color(195, 180,  0)
                                            ,new Color(200, 130, 0)
                                            ,new Color(170, 30, 30)
	//case 1: g.setColor(new Color(157, 119, 119)); break;
	//case 2: g.setColor(new Color(175,  98,  98)); break;
	//case 3: g.setColor(new Color(197,  70,  70)); break;
                                            ,new Color(0, 140, 105)
                                            ,new Color(140, 180, 235)
                                            ,new Color(70, 120, 175)
                                            ,new Color(10, 60, 140)
                                            ,new Color(75, 70, 70)};
    static Color COLOR_EXTINGUISHABLE   = Color.blue.brighter();
    static Color COLOR_ROAD_HEAD = new Color(185, 185, 185);
    static Color COLOR_ROAD_TAIL = Color.green.darker();
    static Color COLOR_ROAD_NOT_SEEN = Color.darkGray;
    static Color COLOR_DEAD      = Color.black;
      // background
    static Color COLOR_BACK_GROUND = new Color(140, 140, 140);
    static Color COLOR_BACK_MESH   = null;
      // message
    static Color COLOR_MSG_SPOKEN  = Color.white;
    static Color COLOR_MSG_HEAR    = Color.black;
    static Color COLOR_MSG_SPOKEN_BACK = new Color(0, 96, 0);
    static Color COLOR_MSG_HEAR_BACK   = Color.white;
      // action
    static Color COLOR_ACT_EXTINGUISH = Color.blue.brighter().brighter();
    ///// values /////
      // movings
    static int   RADIUS_MOVING         = 3500;
    static int   SAME_PLACE_INTERVAL   = 3;
    static int   TIME_CONTINUE_MARKED  = 2000;
    static int   RADIUS_MSG_SPEAKING   = 50;
    static int   RADIUS_MSG_SPEAKING_B = 75;
      // time
    static int   TIME_INTERVAL_TURN      = 1000;
    private static int ANIMATION_DIVISION = 15;
    ///// booleans ////
    static boolean SHOW_DETAIL_CLICKED = false;
    static boolean USE_ANIMATION  = true;
    static boolean OREDER_OVERLAPPED = true;
    static boolean SHOW_BUILDING_BROKEN = false;

    private static boolean finish_read = false;
    private static int    current_line = 1;
    ///////////////////////
    private static Confing m_instance = new Confing();
    public static Confing getInstance() { return m_instance; }
    public static String ConfingFileName;
    private Confing() {
        java.net.URL url = getClass().getResource("../");
        StringBuffer sb = new StringBuffer(url.getPath());
        String dir = sb.substring(sb.length()-8, sb.length());
        if(dir.equals("classes/")) dir = sb.substring(0, sb.length()-8);
        else dir = url.getPath();
        ConfingFileName = dir + "confing.txt";
        NAME_SCOPE_LOG  = dir + "scopeRescue.log";
        //// delete windows's space ////
        sb = new StringBuffer(ConfingFileName);
        int space = sb.indexOf("%20");
        while(space >= 0){
          sb = sb.delete(space, space+3);
          sb.insert(space, ' ');
          space = sb.indexOf("%20");
        }
        ConfingFileName = sb.toString();
    }

    private static void err(String msg){ System.err.println("[Confing file, "+"at line "+current_line+"] "+msg); }

    public static void readConfingFile() throws FileNotFoundException{
        InputStream is;
        BufferedReader br;
            is = new FileInputStream(ConfingFileName);
            br = new BufferedReader(new InputStreamReader(is));
        try{
            System.out.println("now reading confing file [" + ConfingFileName + "]");
            for(String read_str = br.readLine(); read_str != null;  read_str = br.readLine(), ++current_line){
                read_str = read_str.trim();
                int comment = read_str.indexOf("#");
                if(comment >= 0) read_str = read_str.substring(0, comment);

                if(read_str.indexOf("COLOR") == 0) setColorParameter(read_str.substring(6, read_str.length()));
                else if(read_str.indexOf("INT") == 0) setIntParameter(read_str.substring(4, read_str.length()));
                else if(read_str.indexOf("LOCATION") == 0) setPointParameter(read_str.substring(9, read_str.length()));
                else if(read_str.indexOf("DIMENSION") == 0) setSizeParameter(read_str.substring(10, read_str.length()));
                else if(read_str.indexOf("IS") == 0) setBoolParameter(read_str.substring(3, read_str.length()));
                else if(read_str.indexOf("STR") == 0)setStrParameter(read_str.substring(4, read_str.length()));
                else {
                    if(read_str.length() != 0   &&   read_str.charAt(0) != ' ') err("("+read_str+") is not confing data");
                }
            }
        } catch(Exception e) {
            e.printStackTrace();
        }

        finish_read = true;
    }
    //////////// Color param
    private static void setColorParameter(String str){
        int space = str.indexOf(" ");
        String agentname = str.substring(0, space);
        if(agentname.equalsIgnoreCase("SELECTED")) COLOR_SELECTED = getColorParameter(str.substring(8, str.length()));
        else if(agentname.equalsIgnoreCase("POLICE")) COLOR_POLICE = getColorParameter(str.substring(7, str.length()));
        else if(agentname.equalsIgnoreCase("AMBULANCE")) COLOR_AMBULANCE = getColorParameter(str.substring(9, str.length()));
        else if(agentname.equalsIgnoreCase("FIRE")) COLOR_FIRE = getColorParameter(str.substring(4, str.length()));
        else if(agentname.equalsIgnoreCase("CIVILIAN")) COLOR_CIVILIAN = getColorParameter(str.substring(8, str.length()));
        else if(agentname.equalsIgnoreCase("DEAD")) COLOR_DEAD = getColorParameter(str.substring(4, str.length()));
        else if(agentname.equalsIgnoreCase("AMBULANCE_CENTER")) COLOR_AMBULANCE_CENTER = getColorParameter(str.substring(16, str.length()));
        else if(agentname.equalsIgnoreCase("FIRE_STATION")) COLOR_FIRE_STATION = getColorParameter(str.substring(12, str.length()));
        else if(agentname.equalsIgnoreCase("POLICE_OFFICE")) COLOR_POLICE_OFFICE = getColorParameter(str.substring(13, str.length()));
        else if(agentname.equalsIgnoreCase("REFUGE")) COLOR_REFUGE = getColorParameter(str.substring(6, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING")) COLOR_BUILDING = getColorParameter(str.substring(8, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_OUTLINE")) COLOR_BUILDING_OUTLINE = getColorParameter(str.substring(17, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_OUTLINE_NOT_SEEN")) COLOR_BUILDING_OUTLINE_NOT_SEEN = getColorParameter(str.substring(26, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_NOT_SEEN")) COLOR_BUILDING_NOT_SEEN = getColorParameter(str.substring(17, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_FIRE_1")) COLOR_BUILDING_FIRE[1] = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_FIRE_2")) COLOR_BUILDING_FIRE[2] = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_FIRE_3")) COLOR_BUILDING_FIRE[3] = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_FIRE_4")) COLOR_BUILDING_FIRE[4] = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_FIRE_5")) COLOR_BUILDING_FIRE[5] = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_FIRE_6")) COLOR_BUILDING_FIRE[6] = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_EXTINGUISHED")) COLOR_BUILDING_FIRE[6] = COLOR_BUILDING_FIRE[5] = getColorParameter(str.substring(21, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_FIRE_7")) COLOR_BUILDING_FIRE[7] = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_FIRE_8")) COLOR_BUILDING_FIRE[8] = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("BUILDING_BURNED_OUT")) COLOR_BUILDING_FIRE[8] = getColorParameter(str.substring(19, str.length()));
        else if(agentname.equalsIgnoreCase("EXTINGUISHABLE")) COLOR_EXTINGUISHABLE = getColorParameter(str.substring(14, str.length()));
        else if(agentname.equalsIgnoreCase("ROAD_HEAD")) COLOR_ROAD_HEAD = getColorParameter(str.substring(9, str.length()));
        else if(agentname.equalsIgnoreCase("ROAD_TAIL")) COLOR_ROAD_TAIL = getColorParameter(str.substring(9, str.length()));
        else if(agentname.equalsIgnoreCase("ROAD_NOT_SEEN")) COLOR_ROAD_NOT_SEEN = getColorParameter(str.substring(13, str.length()));
        else if(agentname.equalsIgnoreCase("BACK_GROUND")) COLOR_BACK_GROUND = getColorParameter(str.substring(11, str.length()));
        else if(agentname.equalsIgnoreCase("BACK_MESH")) COLOR_BACK_MESH = getColorParameter(str.substring(9, str.length()));
        else if(agentname.equalsIgnoreCase("MSG_HEAR")) COLOR_MSG_HEAR = getColorParameter(str.substring(8, str.length()));
        else if(agentname.equalsIgnoreCase("MSG_HEAR_BACK")) COLOR_MSG_HEAR_BACK = getColorParameter(str.substring(13, str.length()));
        else if(agentname.equalsIgnoreCase("MSG_SPOKEN")) COLOR_MSG_SPOKEN = getColorParameter(str.substring(10, str.length()));
        else if(agentname.equalsIgnoreCase("MSG_SPOKEN_BACK")) COLOR_MSG_SPOKEN_BACK = getColorParameter(str.substring(15, str.length()));
        else if(agentname.equalsIgnoreCase("ACT_EXTINGUISH")) COLOR_ACT_EXTINGUISH = getColorParameter(str.substring(14, str.length()));
        else err("'"+ agentname+"' confing data does not exist.");
    }

    private static Color getColorParameter(String col){
        col = col.trim();
        Color variable = null;
        try{ int colorInt = Integer.parseInt(col);  variable = new Color(colorInt); }
        catch(Exception e){
            /// color name
            int darker = col.indexOf(".darker"),  brighter = col.indexOf(".brighter");
            if(darker != -1) col = col.substring(0, darker);
            if(brighter != -1) col = col.substring(0, brighter);

            if(col.equalsIgnoreCase("BLACK")) variable = Color.black;
            else if(col.equalsIgnoreCase("CYAN")) variable = Color.cyan;
            else if(col.equalsIgnoreCase("BLUE")) variable = Color.blue;
            else if(col.equalsIgnoreCase("GREEN")) variable = Color.green;
            else if(col.equalsIgnoreCase("GRAY"))  variable = Color.gray;
            else if(col.equalsIgnoreCase("ORANGE")) variable = Color.orange;
            else if(col.equalsIgnoreCase("PINK")) variable = Color.pink;
            else if(col.equalsIgnoreCase("PURPLE")) variable = new Color(255, 0, 255);
            else if(col.equalsIgnoreCase("RED")) variable = Color.red;
            else if(col.equalsIgnoreCase("MAGENTA")) variable = Color.magenta;
            else if(col.equalsIgnoreCase("YELLOW")) variable = Color.yellow;
            else if(col.equalsIgnoreCase("WHITE")) variable = Color.white;
            else if(col.equalsIgnoreCase("NULL") || col.equalsIgnoreCase("NILL")) return null;
            /// color RGB "(R, G, B)"
            if(variable == null){
                try{
                    int r=0, g=0, b=0;
                    col = col.substring(1);
                    StringTokenizer st = new StringTokenizer(col);
                    r = Integer.parseInt(st.nextToken(", )"));
                    g = Integer.parseInt(st.nextToken());
                    b = Integer.parseInt(st.nextToken());
                    variable = new Color(r, g, b);
                } catch(Exception e2){ err("Color Number Error:"+col);}
            }
            /// error
            if(variable == null) variable = Color.white;
            //////////
            if(darker != -1  &&  variable!=null)   variable = variable.darker();
            if(brighter != -1  &&  variable!=null) variable = variable.brighter();
        }
        return variable;
    }
    ///// Int Param ///////////////////////////
    private static void setIntParameter(String data) {
        int space = data.indexOf(" ");
        String name = data.substring(0, space);
        if(name.equalsIgnoreCase("INTERVAL_SAME_PLACE")) SAME_PLACE_INTERVAL = getIntParameter(data.substring(space, data.length()));
        else if(name.equalsIgnoreCase("TIME_CONTINUE_MARKED")) TIME_CONTINUE_MARKED = getIntParameter(data.substring(space, data.length()));
        else if(name.equalsIgnoreCase("RADIUS_MSG_SPEAKING")) RADIUS_MSG_SPEAKING = getIntParameter(data.substring(space, data.length()));
        else if(name.equalsIgnoreCase("TIME_INTERVAL_TURN")) TIME_INTERVAL_TURN = getIntParameter(data.substring(space, data.length()));
        else if(name.equalsIgnoreCase("MODE_VIEWER_SHOW")) MODE_VIEWER_SHOW = getIntParameter(data.substring(space, data.length()));
        else if(name.equalsIgnoreCase("ANIMATION_DIVISION")) ANIMATION_DIVISION = getIntParameter(data.substring(space, data.length()));
        else if(name.equalsIgnoreCase("RADIUS_HUMANOID") || name.equalsIgnoreCase("RADIUS_MOVING"))
            RADIUS_MOVING = getIntParameter(data.substring(space, data.length()));
        else err("at line"+current_line+". '"+ name+"' confing data does not exist.");
    }

    private static int getIntParameter(String data) {
        data = data.trim();
        try{
            return Integer.parseInt(data);
        } catch(Exception e){ err("eleagal number: "+ data); }
        return 0;
    }

    ///// Point Param /////
    private static void setPointParameter(String data) {
        int space = data.indexOf(" ");
        String name = data.substring(0, space);
        if(name.equalsIgnoreCase("ACTION_VIEWER")) LOCATION_ACTION_VIEWER = getPointParameter(data.substring(space, data.length()));
        else if(name.equalsIgnoreCase("MAIN_VIEW")) LOCATION_MAIN_VIEW = getPointParameter(data.substring(space, data.length()));
        else err("'"+ name+"' confing data does not exist.");
    }

    private static Point getPointParameter(String data) {
        int x=0, y=0;
        data = data.trim();
        String tmpS = data.substring(1);  //// remove '('
        try{
            StringTokenizer st = new StringTokenizer(tmpS);
            x = Integer.parseInt(st.nextToken(" ,)"));
            y = Integer.parseInt(st.nextToken());
        } catch(Exception e){ err("eleagal point: "+ data); x=y=0; }
        return new Point(x, y);
    }

    private static void setSizeParameter(String data) {
        int space = data.indexOf(" ");
        String name = data.substring(0, space);
        Point p = getPointParameter(data.substring(space, data.length()));
        if(name.equalsIgnoreCase("ACTION_VIEWER"));
        else if(name.equalsIgnoreCase("MAIN_VIEW")) DIMENSION_MAIN_VIEW = new Dimension(p.x, p.y);
        else err("'"+ name+"' confing data does not exist.");
    }
    ///// Boolean Param /////
    private static void setBoolParameter(String data) {
        int space = data.indexOf(" ");
        String name = data.substring(0, space);
        boolean b = getBoolParameter(data.substring(space, data.length()));
        if(name.equalsIgnoreCase("SHOW_DETAIL_CLICKED")) SHOW_DETAIL_CLICKED = b;
        else if(name.equalsIgnoreCase("USE_ANIMATION")) USE_ANIMATION = b;
        else if(name.equalsIgnoreCase("OREDER_OVERLAPPED")) OREDER_OVERLAPPED = b;
        else if(name.equalsIgnoreCase("SHOW_BUILDING_BROKEN")) SHOW_BUILDING_BROKEN = b;
        else if(name.equalsIgnoreCase("MAKE_SCOPE_LOG")) MAKE_SCOPE_LOG = b;
        else err("'"+ name+"' confing data does not exist.");
    }

    private static boolean getBoolParameter(String data) {
        data = data.trim();
        try{
            if(data.equalsIgnoreCase("TRUE")) return true;
        } catch(Exception e){ err("eleagal value: "+ data); }
        return false;
    }
    ///// String Param /////
    private static void setStrParameter(String data) {
        int space = data.indexOf(" ");
        String name = data.substring(0, space);
        String value= data.substring(space, data.length()).trim();
        if(name.equalsIgnoreCase("NAME_SCOPE_LOG")) NAME_SCOPE_LOG = value;
    }
    ////////////////////////////////////////////////////////////////
    //// get method
    ////////////////////////////////////////////////////////////////
    public static int   intExpandAreaLength()  { return EXPAND_AREA_LENGTH; }
    public static int   timeIntervalTurn() { return TIME_INTERVAL_TURN; }
    public static int   animationDivision(){ return ANIMATION_DIVISION; }
    public static boolean isSimpleStatus() { return SIMPLE_STATUS; }
    public static int  intSelectMode()     { return SELECT_MODE; }
    public static int  intSizeActionAnimation() { return SIZE_ACTION_ANIMATION; }
    public static boolean isDrawOutlineRoad() { return DRAW_OUTLINE_ROAD; }
    //
    public static Color colorExtinguishing() { return COLOR_EXTINGUISHING; }
    public static Color colorSelected() { return COLOR_SELECTED; }
    public static Color colorPolice()   { return COLOR_POLICE; }
    public static Color colorAmbulance(){ return COLOR_AMBULANCE; }
    public static Color colorFire()     { return COLOR_FIRE; }
    public static Color colorCivilian() { return COLOR_CIVILIAN; }
    public static Color colorDead()     { return COLOR_DEAD; }
    public static Color colorAmbulanceCenter() { return COLOR_AMBULANCE_CENTER; }
    public static Color colorFireStation() { return COLOR_FIRE_STATION; }
    public static Color colorPoliceOffice() { return COLOR_POLICE_OFFICE; }
    public static Color colorRefuge()   { return COLOR_REFUGE; }
    public static Color colorBuilding() { return COLOR_BUILDING; }
    public static Color colorBuildingOutline(){ return COLOR_BUILDING_OUTLINE; }
    public static Color colorBuildingNotSeen(){ return COLOR_BUILDING_NOT_SEEN; }
    public static Color colorBuildingOutlineNotSeen() { return COLOR_BUILDING_OUTLINE_NOT_SEEN; }
    public static Color colorBuildingFire(int f) { return COLOR_BUILDING_FIRE[f]; }
    public static Color colorExtinguishable()    { return COLOR_EXTINGUISHABLE; }
    public static Color colorRoadHead() { return COLOR_ROAD_HEAD; }
    public static Color colorRoadTail() { return COLOR_ROAD_TAIL; }
    public static Color colorRoadNotSeen(){ return COLOR_ROAD_NOT_SEEN; }
    public static Color colorBackMesh() { return COLOR_BACK_MESH; }
    public static Color colorBackGround()   { return COLOR_BACK_GROUND; }
    public static Color colorMsgHear()      { return COLOR_MSG_HEAR; }
    public static Color colorMsgHearBack()  { return COLOR_MSG_HEAR_BACK; }
    public static Color colorMsgSpoken()    { return COLOR_MSG_SPOKEN; }
    public static Color colorMsgSpokenBack(){ return COLOR_MSG_SPOKEN_BACK; }
    public static Color colorActionExtinguish(){ return COLOR_ACT_EXTINGUISH; }
    public static int   intMovingRadius()      { return RADIUS_MOVING; }
    public static int   intSamePlaceInterval() { return SAME_PLACE_INTERVAL; }
    public static int   intTimeContinueMarked(){ return TIME_CONTINUE_MARKED; }
    public static int   intSpeakingRadius()    { return RADIUS_MSG_SPEAKING; }
    public static int   intModeViewerShow()    { return MODE_VIEWER_SHOW; }
    public static Point pointActionViewer()    { return LOCATION_ACTION_VIEWER; }
    public static Point pointMainView()        { return LOCATION_MAIN_VIEW; }
    public static Dimension dimensionMainView(){ return DIMENSION_MAIN_VIEW; }
    public static boolean isShowDetailClicked(){ return SHOW_DETAIL_CLICKED; }
    public static boolean isUseAnimation()     { return USE_ANIMATION; }
    public static boolean isOrderOverLapped()  { return OREDER_OVERLAPPED; }
    public static boolean isShowBuildingBroken(){return SHOW_BUILDING_BROKEN; }
    public static boolean isShowWorldModel()   { return SHOW_WORLDMODEL; }
    public static boolean isShowAgentAction()  { return SHOW_AGENT_ACTION; }
    public static boolean isShowMessageSpeaking(){ return SHOW_MSG_SPEAKING; }
    public static boolean isOnline()           { return IS_ONLINE; }
    public static boolean isMakeScopeLog()     { return MAKE_SCOPE_LOG; }
    public static String  strScopeLogName()    { return NAME_SCOPE_LOG; }
        //// change
    public static void changeUseAnimation()    { USE_ANIMATION = !USE_ANIMATION; }
    public static void changeOrderOverLapped() { OREDER_OVERLAPPED = !OREDER_OVERLAPPED; }
    public static void changeShowBuildingBroken(){ SHOW_BUILDING_BROKEN = !SHOW_BUILDING_BROKEN; }
    public static void changeShowWorldModel()  { SHOW_WORLDMODEL = !SHOW_WORLDMODEL; }
    public static void changeShowAgentAction() { SHOW_AGENT_ACTION = !SHOW_AGENT_ACTION; }
    public static void changeShowMessageSpeaking(){ SHOW_MSG_SPEAKING = !SHOW_MSG_SPEAKING; }
    public static void changeOnline(boolean b) { IS_ONLINE = b; }
    public static void changeModeViewerShow(int s) { MODE_VIEWER_SHOW = s; }
    public static void changeDrawOutlineRoad() { DRAW_OUTLINE_ROAD = !DRAW_OUTLINE_ROAD; }
    public static void setAnimationDivision(int d) { ANIMATION_DIVISION = d; }
   ////////////////////////////////////////////////////////////////
    //// write
    ////////////////////////////////////////////////////////////////
    public static void writeConfingFile() throws IOException{
        OutputStream fos = new FileOutputStream(ConfingFileName);
        DataOutputStream dos = new DataOutputStream(fos);
        try{
            System.out.println("save confingfile [" + ConfingFileName + "]");
            dos.writeBytes("############# Colors ################\n");
            dos.writeBytes("  ## Object ##\n");
            dos.writeBytes(getWrittenString("COLOR_POLICE", getStringFromColor(COLOR_POLICE)));
            dos.writeBytes(getWrittenString("COLOR_AMBULANCE", getStringFromColor(COLOR_AMBULANCE)));
            dos.writeBytes(getWrittenString("COLOR_FIRE", getStringFromColor(COLOR_FIRE)));
            dos.writeBytes(getWrittenString("COLOR_CIVILIAN", getStringFromColor(COLOR_CIVILIAN)));
            dos.writeBytes(getWrittenString("COLOR_DEAD", getStringFromColor(COLOR_DEAD)));
            dos.writeBytes(getWrittenString("COLOR_BUILDING", getStringFromColor(COLOR_BUILDING)));
            dos.writeBytes(getWrittenString("COLOR_AMBULANCE_CENTER", getStringFromColor(COLOR_AMBULANCE_CENTER)));
            dos.writeBytes(getWrittenString("COLOR_FIRE_STATION", getStringFromColor(COLOR_FIRE_STATION)));
            dos.writeBytes(getWrittenString("COLOR_POLICE_OFFICE", getStringFromColor(COLOR_POLICE_OFFICE)));
            dos.writeBytes(getWrittenString("COLOR_REFUGE", getStringFromColor(COLOR_REFUGE)));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_OUTLINE", getStringFromColor(COLOR_BUILDING_OUTLINE)));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_NOT_SEEN", getStringFromColor(COLOR_BUILDING_NOT_SEEN)));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_OUTLINE_NOT_SEEN", getStringFromColor(COLOR_BUILDING_OUTLINE_NOT_SEEN)));
            dos.writeBytes(getWrittenString("COLOR_EXTINGUISHABLE", getStringFromColor(COLOR_EXTINGUISHABLE)));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_OUTLINE", getStringFromColor(COLOR_BUILDING_OUTLINE)));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_EXTINGUISHED", getStringFromColor(COLOR_BUILDING_FIRE[6])));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_FIRE_1", getStringFromColor(colorBuildingFire(1))));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_FIRE_2", getStringFromColor(colorBuildingFire(2))));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_FIRE_3", getStringFromColor(colorBuildingFire(3))));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_FIRE_4", getStringFromColor(colorBuildingFire(4))));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_FIRE_5", getStringFromColor(colorBuildingFire(5))));
            dos.writeBytes(getWrittenString("COLOR_BUILDING_BURNED_OUT", getStringFromColor(colorBuildingFire(8))));
            dos.writeBytes(getWrittenString("COLOR_ROAD_HEAD", getStringFromColor(COLOR_ROAD_HEAD)));
            dos.writeBytes(getWrittenString("COLOR_ROAD_TAIL", getStringFromColor(COLOR_ROAD_TAIL)));
            dos.writeBytes(getWrittenString("COLOR_ROAD_NOT_SEEN", getStringFromColor(COLOR_ROAD_NOT_SEEN)));
            dos.writeBytes("  ## BACK ##\n");
            dos.writeBytes(getWrittenString("COLOR_BACK_MESH", getStringFromColor(COLOR_BACK_MESH)));
            dos.writeBytes(getWrittenString("COLOR_BACK_GROUND", getStringFromColor(COLOR_BACK_GROUND)));
            dos.writeBytes("  ## MESSAGE ##\n");
            dos.writeBytes(getWrittenString("COLOR_MSG_HEAR", getStringFromColor(COLOR_MSG_HEAR)));
            dos.writeBytes(getWrittenString("COLOR_MSG_HEAR_BACK", getStringFromColor(COLOR_MSG_HEAR_BACK)));
            dos.writeBytes(getWrittenString("COLOR_MSG_SPOKEN", getStringFromColor(COLOR_MSG_SPOKEN)));
            dos.writeBytes(getWrittenString("COLOR_MSG_SPOKEN_BACK", getStringFromColor(COLOR_MSG_SPOKEN_BACK)));
            dos.writeBytes("  ## ACTION ##\n");
            dos.writeBytes(getWrittenString("COLOR_ACT_EXTINGUISH", getStringFromColor(COLOR_ACT_EXTINGUISH)));
            dos.writeBytes("\n#### INT VALUES ####\n");
            dos.writeBytes(getWrittenString("INT_RADIUS_HUMANOID", RADIUS_MOVING + "  #millimeters of map"));
            dos.writeBytes(getWrittenString("INT_INTERVAL_SAME_PLACE", SAME_PLACE_INTERVAL + "     #pixels"));
            dos.writeBytes(getWrittenString("INT_TIME_CONTINUE_MARKED", TIME_CONTINUE_MARKED + "  #milliseconds"));
            dos.writeBytes(getWrittenString("INT_MODE_VIEWER_SHOW", MODE_VIEWER_SHOW + "     #0:confing, 1:for contest"));
            dos.writeBytes("  ## TIME ##\n");
            dos.writeBytes(getWrittenString("INT_TIME_INTERVAL_TURN", TIME_INTERVAL_TURN + "  #milliseconds"));
            dos.writeBytes(getWrittenString("INT_ANIMATION_DIVISION", ANIMATION_DIVISION + "    #/turn"));
            dos.writeBytes("\n#### LOCATION && SIZE ####\n");
            dos.writeBytes(getWrittenString("LOCATION_ACTION_VIEWER", getStringFromXY(LOCATION_ACTION_VIEWER) + ""));
            dos.writeBytes(getWrittenString("LOCATION_MAIN_VIEW", getStringFromXY(LOCATION_MAIN_VIEW) + ""));
            dos.writeBytes(getWrittenString("DIMENSION_MAIN_VIEW", getStringFromXY(DIMENSION_MAIN_VIEW) + ""));
            dos.writeBytes("\n#### BOOL ####\n");
            dos.writeBytes(getWrittenString("IS_USE_ANIMATION", USE_ANIMATION + ""));
            dos.writeBytes(getWrittenString("IS_OREDER_OVERLAPPED", OREDER_OVERLAPPED + ""));
            dos.writeBytes(getWrittenString("IS_SHOW_BUILDING_BROKEN", SHOW_BUILDING_BROKEN + ""));
            dos.writeBytes(getWrittenString("IS_MAKE_SCOPE_LOG", MAKE_SCOPE_LOG + ""));
            dos.writeBytes("\n#### STRIING ####\n");
            dos.writeBytes(getWrittenString("STR_NAME_SCOPE_LOG", NAME_SCOPE_LOG + "  #absolute"));

        } finally{ fos.close(); }
    }
    private static String getWrittenString(String head, String value) {
        StringBuffer sb = new StringBuffer(head);
        sb.append(' ');
        int len = sb.length();
        for(int i=len; i<HEAD_LENGTH; ++i) sb.append(' ');
        sb.append(value + "\n");
        return new String("  " + sb);
    }
    private static String getStringFromColor(Color c) {
        String str;
        if(c != null) str = "(" + c.getRed() + ", " + c.getGreen() + ", " + c.getBlue() + ")";
        else return "null";
        if(c.equals(Color.black)) str = "black";
        else if(c.equals(Color.blue)) str = "blue";
        else if(c.equals(Color.cyan)) str = "cyan";
        else if(c.equals(Color.green)) str = "green";
        else if(c.equals(Color.gray)) str = "gray";
        else if(c.equals(Color.orange)) str = "orange";
        else if(c.equals(Color.pink)) str = "pink";
        else if(c.equals(new Color(255,0,255))) str = "purple";
        else if(c.equals(Color.magenta)) str = "magenta";
        else if(c.equals(Color.red)) str = "red";
        else if(c.equals(Color.yellow)) str = "yellow";
        else if(c.equals(Color.white)) str = "white";
        return str;
    }
    private static String getStringFromXY(Object o) {
        String str = "null";
        if(o == null) return "null";
        if(o instanceof Point){
            Point p = (Point)o;
            str = "(" + p.x + ", " + p.y + ")";
        } else if(o instanceof Dimension){
            Dimension d = (Dimension)o;
            str = "(" + d.width + ", " + d.height + ")";
        }
        return str;
    }
    ////////////////////////////////////////////////////////////////
    //// for debug
    ////////////////////////////////////////////////////////////////
    public static void main(String args[]){
        ConfingFileName = args[0];
        Confing c = new Confing();
        System.out.println("start debug");
        try{
            readConfingFile();
        } catch(Exception e){ e.printStackTrace(); }
        try{
            writeConfingFile();
        } catch(Exception e){ e.printStackTrace(); }
        while(true);
    }
}
