package debugger;

import java.util.*;
import java.awt.Color;
import debugger.object.*;
import debugger.view.*;

public interface Constants extends PropertyConstants, TypeConstants, HeaderConstants {
  // WorldModel
  static final WorldModel WORLD = new WorldModel();

  // IO
  static final int PACKET_SIZE = 1472;  // [byte] {cf. send_udp_size @ RUN/confing.txt}
  static final int DEFAULT_KERNEL_PORT = 6000;
  static final String ACTION_LOG_FILE_NAME = "./action.log";//"action.log";

  // Viewer
  static final Viewer VIEWER = new Viewer();
  static final int VIEWER_DEFAULT_INTERVAL_EACH_CYCLE = 1000; // [m sec]
  static final int VIEWER_INTERVAL_EACH_EXPOSURE = 50; // [m sec]
  static final boolean VIEWER_DO_ANIMATION_AS_A_DEFAULT = true;
  static final int VIEWER_WIDTH  = 650;
  static final int VIEWER_HEIGHT = 550;
  static final int VIEWER_GAP = 50;
  static final int VIEWER_HUMANOID_SIZE = 12;
  static final int VIEWER_BLOCKADE_SIZE =  4;
  static final int VIEWER_NODE_SIZE     =  2;
  static final int VIEWER_ROAD_MAX_WIDTH = 2000; // [mm]
  static final int VIEWER_BACKGROUND_OF_ATTENTED_OBJECT_SIZE = 20;
  static final int VIEWER_SCROLL_LENGTH = 1000; // [mm]

  static final MessageViewer MSG_VIEWER = new MessageViewer();
  static final AgentIDViewer AGENT_VIEWER = new AgentIDViewer();
  static final StatusViewer  STATUS_VIEWER = new StatusViewer();
  static final Color VIEWER_SELECTED_COLOR = Color.cyan;
  static final Color VIEWER_SELECTED_PARENT_COLOR = Color.cyan.darker();
}
