package debugger.view;

import javax.swing.event.*;
import javax.swing.table.*;

/** TODO synchronize model **/
public class SortDecorator implements TableModel, TableModelListener{
  private TableModel m_model;
  private int[] m_indice;

  public SortDecorator(TableModel model) {
    if(model == null) assert false;
    this.m_model = model;
    m_model.addTableModelListener(this);
    allocate();
  }

  public void tableChanged(TableModelEvent e) { allocate(); }
  private void allocate() {
    m_indice = new int[getRowCount()];
    for (int i = 0; i < m_indice.length; i++) m_indice[i] = i;
  }

  public void sort(int column) { sort(column, true); }
  public void sort(int column, boolean isSmaller) {
    int rowCount = getRowCount();

    for (int i = 0; i < rowCount; i++) {
      for (int j = i + 1; j < rowCount; j++) {
        if(isSmaller){ if(compare(m_indice[i], m_indice[j], column) < 0) swap(i, j); }
        else if(compare(m_indice[i], m_indice[j], column) == 0) swap(i, j);
      }
    }
  }
  public void swap(int i, int j) {
    int tmp = m_indice[i];
    m_indice[i] = m_indice[j];
    m_indice[j] = tmp;
  }
  public int compare(int i, int j, int column) {
    Object io = m_model.getValueAt(i, column),
           jo = m_model.getValueAt(j, column);
    int c = 0;
    try{
      int ii = Integer.parseInt(io.toString()),
          ji = Integer.parseInt(jo.toString());
      c = (ii <= ji)? 0: -1;
    } catch(Exception e){
      c = jo.toString().compareTo(io.toString());
    }
    return (c < 0) ? -1 : ((c > 0)? 1 : 0);
  }

  ////////////////// These are done by Tablemodel //////////////////
  public int getRowCount() {
    return m_model.getRowCount();
  }
  public int getColumnCount() {
    return m_model.getColumnCount();
  }
  public Object getValueAt(int row, int column) {
    synchronized(m_model){
      return m_model.getValueAt(m_indice[row], column);
    }
  }
  public void setValueAt(Object aValue, int row, int column) {
    m_model.setValueAt(aValue, m_indice[row], column);
  }
  public String getColumnName(int column) {
    return m_model.getColumnName(column);
  }
  public Class getColumnClass(int column) {
    return m_model.getColumnClass(column);
  }
  public boolean isCellEditable(int row, int col) {
    return m_model.isCellEditable(row, col);
  }
  public void addTableModelListener(TableModelListener l) {
    m_model.addTableModelListener(l);
  }
  public void removeTableModelListener(TableModelListener l) {
    m_model.removeTableModelListener(l);
  }
}
